ZOBR16_M	MACRO	COH,COL,CISLICE,ZNAK_0,VYPIS,DELENI,AA,BB,CC
; podprogram zobrazuje 16bitovou hodnotu v [COH:COL]

; bity v hodnote "CISLICE" urcuji, ktere cislice se budou zobrazovat
; "ZNAK_0" je adresou znaku "0" (nula) na displeji
; "VYPIS" je flash adresa (navesti) podprogramu, ktery vypise znak, ulozeny ve W, na displej
; "DELENI" je flash adresa podprogramu, ktery provadi 16bitove deleni AA:2/BB:2 = CC:2 a zbytek uklada do AA:2
; AA,BB,CC jsou adresy dvoubajtovych operandu, ktere pouziva zmineny algoritmus deleni

	IF COH > 0		; pokud je adresa vstupu nulova,...
	banksel	COL
	MOVF	COL,W
	ENDIF
	banksel	AA		; ...predpoklada se 8bitovy vstup, a sice pracovni registr W...
	MOVWF	AA
	IF COH > 0
	banksel	COH
	MOVF	COH,W
	banksel	AA + 1
	MOVWF	AA + 1
	ELSE
	banksel	AA + 1
	CLRF	AA + 1		; ...a v tom pripade muzeme AA+1 vynulovat
	ENDIF
	MOVLW	D'10000' / D'256'
	MOVWF	BB + 1
	MOVLW	D'10000' % D'256'	;(symbol "%" znaci modulo, nebo-li zbytek po deleni)
	MOVWF	BB
	CALL	DELENI		; deleno 10000
	IF (CISLICE & B'00010000') > 0; bude se vypisovat 5. znak?
	MOVF	CC,W
	ADDLW	ZNAK_0
	CALL	PUTZNAK
	ENDIF
	MOVLW	D'1000' / D'256'	; v AA je zbytek po predchocim deleni
	MOVWF	BB + 1
	MOVLW	D'1000' % D'256'
	MOVWF	BB
	CALL	DELENI		; deleno 1000
	IF (CISLICE & B'00001000') > 0; bude se vypisovat 4. znak?
	MOVF	CC,W
	ADDLW	ZNAK_0
	CALL	PUTZNAK
	ENDIF
	CLRF	BB + 1		; zbytek po deleni je v AA...
	MOVLW	D'100'
	MOVWF	BB
	CALL	DELENI		; ...dale delime cislem 100
	IF (CISLICE & B'00000100') > 0; bude se vypisovat 3. znak?
	MOVF	CC,W
	ADDLW	ZNAK_0
	CALL	PUTZNAK
	ENDIF
	MOVLW	D'10'
	MOVWF	BB
	CALL	DELENI		; delime cislem 10
	IF (CISLICE & B'00000010') > 0; bude se vypisovat 2. znak?
	MOVF	CC,W
	ADDLW	ZNAK_0
	CALL	PUTZNAK
	ENDIF
	IF (CISLICE & B'00000001') > 0; bude se vypisovat 1. znak?
	MOVF	AA,W
	ADDLW	ZNAK_0
	CALL	PUTZNAK
	ENDIF
	RETURN

	ENDM
