PARIT_COM	MACRO	PARITREG1,PARITREG2,TEMP1,TEMP2
; sada dvou podprogramu, ktere zajistuji seriovy prenos s paritou...
; ...a pouzivaji hardwarove podpory mikrokontroleru
; - doplnuje se na SUDOU paritu -

	LOCAL	SKOK

; vysle znak, ale pred tim k nemu prida paritni bit
; - vstupem je byte v pracovnim registru W
TX_PARIT	MOVWF	TEMP1		; uschovani vstupu
	MOVWF	PARITREG1		; zkopirovani do PARITREG1
	RRF	PARITREG1,W	; zacina vypocet parity:
	XORWF	PARITREG1,F
	SWAPF	PARITREG1,W
	XORWF	PARITREG1,F
	RRF	PARITREG1,W
	RLF	PARITREG1,F
	XORWF	PARITREG1,F	; parita vypoctena, nachazi se v bitu 1
	banksel	TXSTA
	BCF	TXSTA,TX9D	; komplikovane preneseni bitu parity do TXSTA,TX9D:
	banksel   PARITREG1
	BTFSS	PARITREG1,1
	GOTO	SKOK
	banksel	TXSTA
	BSF	TXSTA,TX9D
	banksel   TEMP1
SKOK	MOVF	TEMP1,W
	MOVWF	TXREG		; vlozenim datoveho bytu do TXREG se spousti prenos...
	RETURN			; ...vcetne devateho bitu v TXSTA,TX9D

; precte znak a zkontroluje paritu
; - precteny znak je vracen ve W
; - pokud je parita chybna bude navic priznak STATUS,Z nastaven na 1...
; ...jinak bude nastaven na 0
RC_PARIT	BCF	STATUS,DC		; prepis bitu RCSTA,RX9D do STATUS,DC...
	BTFSC	RCSTA,RX9D	; ...(muzeme s klidem vyuzit misto pro priznakovy bit DC)
	BSF	STATUS,DC
	MOVF	RCREG,W		; precteni datoveho bytu...
	MOVWF	TEMP2		; ...a jeho uschovani
	MOVWF	PARITREG2		; byte je zkopirovan do PARITREG2
	RRF	PARITREG2,W	; zacina vypocet parity:
	XORWF	PARITREG2,F
	SWAPF	PARITREG2,W
	XORWF	PARITREG2,F
	RRF	PARITREG2,W
	RLF	PARITREG2,F
	XORWF	PARITREG2,F	; parita spoctena
	MOVF	STATUS,W		; porovnani s paritou, ulozenou ve STATUS,DC
	XORWF	PARITREG2,W
	ANDLW	B'00000010'	; pokud jsou parity shodne je vysledek nulovy...
	SWAPF	TEMP2,F		; ...a nastavi se priznak STATUS,Z
	SWAPF	TEMP2,W		; do W je vracen datovy byte, ale nesmi se porusit priznak Z
	RETURN

	ENDM
